function B = ElasticNetXYcvforpaper2Adap(Xtr,Ytr,G1,G2)
%%%Inputs:
%Xtr design matrix of the training sample
%Ytr labels vector of the training sample
%G1  cv grid for lambda1
%G2  cv grid for lambda2

%%%Outputs: 
%f.salphabeta estimations of s, alpha and beta.
%f.lambdasopt regularization parameter.


%Xtr est de taille n*p
%Ytr est un vecteur colonne de taille n

q1=length(G1);
q2=length(G2);
[n,p]=size(Xtr);
M=1.345;
%u1,u2,u3,u4 and u5 start at 0.
u1=zeros(q1,q2);
u2=zeros(q1,q2);
u3=zeros(q1,q2);
u4=zeros(q1,q2);
u5=zeros(q1,q2);


%Calculating the unpenalized estimator on the whole training sample.

%Standardisation de Xtr prealable au calcul du poids adaptatif
%sqtr=sqrt(sum(Xtr.^2));
%Xtr1=Xtr*diag(1./sqtr);

%En cas de normalisation pour le poids adaptatif, mettre Xtr1 a la palce de Xtr dans le probleme d'optimisation qui suit.

cvx_begin
variables alphaaOLS betaUNP(p) s v(n);
minimize (n*s+quad_over_lin(Ytr-alphaaOLS-Xtr*betaUNP-v,s)+2*M*norm(v,1))
subject to
s > 0;
cvx_end

% 5 decoupages en 2 parties de l'echantillon d'apprentissage

T=decoup(Xtr,Ytr);

%Calcule des erreurs de generalisation des differents lambda sur chacun des 5 decoupages.

for i=1:q1,
for j=1:q2,
lambda1=G1(i);
lambda2=G2(j);
u1(i,j)=ElasticNetcvdetailsforpaper2AdapHubercc(T.Xtraining{1},T.Ytraining{1},T.Xtest{1},T.Ytest{1},lambda1,lambda2,betaUNP);
u2(i,j)=ElasticNetcvdetailsforpaper2AdapHubercc(T.Xtraining{2},T.Ytraining{2},T.Xtest{2},T.Ytest{2},lambda1,lambda2,betaUNP);
u3(i,j)=ElasticNetcvdetailsforpaper2AdapHubercc(T.Xtraining{3},T.Ytraining{3},T.Xtest{3},T.Ytest{3},lambda1,lambda2,betaUNP);
u4(i,j)=ElasticNetcvdetailsforpaper2AdapHubercc(T.Xtraining{4},T.Ytraining{4},T.Xtest{4},T.Ytest{4},lambda1,lambda2,betaUNP);
u5(i,j)=ElasticNetcvdetailsforpaper2AdapHubercc(T.Xtraining{5},T.Ytraining{5},T.Xtest{5},T.Ytest{5},lambda1,lambda2,betaUNP);
end
end
%moyenne des erreurs de generalisation de chaque lambda (moyenne sur les 5 decoupages).

u=(u1+u2+u3+u4+u5)/5;
[a,b]=min(u);
[c,d]=min(a);
lambda2opt=G2(d);
lambda1opt=G1(b(d));

H=ElasticNetXYlambdaAdapHubercc(Xtr,Ytr,lambda1opt,lambda2opt,betaUNP);
B.salphabeta=H.salphabeta;
B.lambdasopt=[lambda1opt;lambda2opt];



