function f=decoup(X,Y)
%Cette fonction divise la matrice X en 5 couples de matrices: c'est la
%bonne forme pour une 5-cross-validation.
%Note:Je retire au plus 4=5-1 donnees pour me simplifier la vie.
%les f.X(Y)training designent des ensembles a 4n/5 donnees et les
%f.X(Y)test designent des ensembles a n/5 donnees.
%l'echantillon test de taille n/5 est d'abord ({1}) les q dernieres lignes
%de X puis ({2}) l'avant derniere partie ... et finallement ({5}) les q
%premieres lignes.
%formule generale pour les indices:
%f.X(Y)training{j} est la concatenation des (5-j)*n/5 premieres donnees et
%des (j-1)*n/5 dernieres. 
%f.X(Y)test{j} est ce qu'il reste.
%Si on numerote les lignes de X par X_1,\cdots,X_n alors,
%f.Xtraining{j} est la concatenation des lignes X_1,\cdots,X_{(5-j)*n/5} et
%X_{(5-j+1)*n/5+1},\cdots,X_{n}
[n,dim]=size(X);
q=fix(n/5);
%q est le diviseur dans la division euclidienne de n par 5.
X=X([1:1:5*q],:);
Y=Y([1:1:5*q],:);
f.Xtraining{1}=X([1:1:4*q],:);
f.Ytraining{1}=Y([1:1:4*q],:);
f.Xtest{1}=X([4*q+1:1:5*q],:);
f.Ytest{1}=Y([4*q+1:1:5*q],:);
f.Xtraining{2}=X([1:1:3*q,4*q+1:1:5*q],:);
f.Ytraining{2}=Y([1:1:3*q,4*q+1:1:5*q],:);
f.Xtest{2}=X([3*q+1:1:4*q],:);
f.Ytest{2}=Y([3*q+1:1:4*q],:);
f.Xtraining{3}=X([1:1:2*q,3*q+1:1:5*q],:);
f.Ytraining{3}=Y([1:1:2*q,3*q+1:1:5*q],:);
f.Xtest{3}=X([2*q+1:1:3*q],:);
f.Ytest{3}=Y([2*q+1:1:3*q],:);
f.Xtraining{4}=X([1:1:q,2*q+1:1:5*q],:);
f.Ytraining{4}=Y([1:1:q,2*q+1:1:5*q],:);
f.Xtest{4}=X([q+1:1:2*q],:);
f.Ytest{4}=Y([q+1:1:2*q],:);
f.Xtraining{5}=X([q+1:1:5*q],:);
f.Ytraining{5}=Y([q+1:1:5*q],:);
f.Xtest{5}=X([1:1:q],:);
f.Ytest{5}=Y([1:1:q],:);
