function f = IHccadapXYlambdaforBICPerteHubercc(Xtr,Ytr,lambda,betaUNP)

%%%Inputs:
%Xtr matrix design of the training data.
%Ytr labels vector of the training data.
%lambda regularization parameter.
%betaUNP unpenalized estimator of the training data. 

%%%Outputs:
%f.stalphabeta estimations of s,t, alpha and beta with regularisation parameter lambda.


p=length(betaUNP);
L=1.345;
M=1.345;
[n,p]=size(Xtr);

%Calculating the estimations of s, tau, alpha and beta.

cvx_begin
variables alphaa betaa(p) tau w(p) s v(n);
minimize (n*s+quad_over_lin(Ytr-alphaa-Xtr*betaa-v,s)+2*M*norm(v,1)+ lambda*(tau*norm(betaUNP,1)+quad_over_lin(w./(sqrt(abs(betaUNP))),2*L*tau)+norm(betaa./betaUNP,1)-sum(w./abs(betaUNP))+0.5*L*tau*norm(1./betaUNP,1)))
subject to
s > 0;
tau > 0;
w >= L*tau;
w >= abs(betaa);
cvx_end
f.stalphabeta=[s;tau;alphaa;betaa(:)];
