function f = PerteHuberccPenIHccAdapBruitDoubleExp(n,m,sig,G,M)
%%%Inputs:
%n size of each training sample.
%m size of the test sample.
%
%G grid for the BIC choice of lambda
%sig a parameter of the model (not necessarily the variance of the noise).
%M number of training samples.

%%%Outputs:
%f.stalphabeta estimations of s, tau, alpha and beta.
%f.RPE Relative Prediction Error.
%f.lambdaopt regularization parameter.

%intercept of the model
alpha0=1;

%coefficient of each covariable
beta0=[3*ones(15,1);zeros(25,1)];
p=length(beta0);

%talphabeta starts at 0
stalphabeta=zeros(p+3,M);

%lambdaopt starts at 0
lambdaopt=zeros(1,M); 

% Reseting the generator of random numbers to its initial state 

rand('state',0); 

randn('state',0);

%generating the design matrix of each training sample

Xtr=XgenerationVeryStrongCorrGroupEffect(n);

%generating the test sample

Xte=XgenerationVeryStrongCorrGroupEffect(m);


for j=1:M,

%generating the labels of the training sample according to the model
Ytr=alpha0+Xtr*beta0+sig*doubleexprnd(n)';

%Calculation of the estimator on the training sample
H=IHccXYBICPerteHubercc(Xtr,Ytr,G);
stalphabeta(:,j)=H.stalphabeta;
lambdaopt(:,j)=H.lambdaopt;

end
%Calculation of the RPE on the test set
beta=stalphabeta(4:end,:);
alpha=stalphabeta(3,:);
betaerr=beta-repmat(beta0,1,M);
alphaerr=alpha-repmat(alpha0,1,M);
alphaerr1=repmat(alphaerr,m,1);
alphabetaerr=alphaerr1+Xte*betaerr;
RPE=mean(alphabetaerr.^2,1)/(2*sig^2);


f.stalphabeta=stalphabeta;
f.RPE=RPE;
f.lambdaopt=lambdaopt;

save stalphabeta3400IHccBICPerteHcc.dat -ASCII stalphabeta
save RPE3400IHccBICPerteHcc.dat -ASCII RPE
save lambdaopt3400IHccBICPerteHcc.dat -ASCII lambdaopt


