function B = RidgeXYcvHubercc(Xtr,Ytr,G)
%%%Inputs:
%Xtr design matrix of the training sample
%Ytr labels vector of the training sample
%G  cv grid for lambda

%%%Outputs: 
%f.salphabeta estimations of s, alpha and beta.
%f.lambdaopt regularization parameter.


%Xtr est de taille n*p
%Ytr est un vecteur colonne de taille n

q=length(G);
[toto,p]=size(Xtr);

%u1,u2,u3,u4 and u5 start at 0.
u1=zeros(1,q);
u2=zeros(1,q);
u3=zeros(1,q);
u4=zeros(1,q);
u5=zeros(1,q);


% 5 decoupages en 2 parties de l'echantillon d'apprentissage

T=decoup(Xtr,Ytr);

%Calcule des erreurs de generalisation des differents lambda sur chacun des 5 decoupages.

for i=1:q,
lambda=G(i);
u1(:,i)=RidgecvdetailsHubercc(T.Xtraining{1},T.Ytraining{1},T.Xtest{1},T.Ytest{1},lambda);
u2(:,i)=RidgecvdetailsHubercc(T.Xtraining{2},T.Ytraining{2},T.Xtest{2},T.Ytest{2},lambda);
u3(:,i)=RidgecvdetailsHubercc(T.Xtraining{3},T.Ytraining{3},T.Xtest{3},T.Ytest{3},lambda);
u4(:,i)=RidgecvdetailsHubercc(T.Xtraining{4},T.Ytraining{4},T.Xtest{4},T.Ytest{4},lambda);
u5(:,i)=RidgecvdetailsHubercc(T.Xtraining{5},T.Ytraining{5},T.Xtest{5},T.Ytest{5},lambda);
end

%moyenne des erreurs de generalisation de chaque lambda (moyenne sur les 5 decoupages).
u=(u1+u2+u3+u4+u5)/5;

[a,b]=min(u);

lambdaopt=G(b);

H=RidgeXYlambdaHubercc(Xtr,Ytr,lambdaopt);
B.salphabeta=H.salphabeta;
B.lambdaopt=lambdaopt;



