function B = RidgeXYlambdaHubercc(Xtr,Ytr,lambda)

%Cette fonction sort et etudie Ridge :
%l'estimateur est calcule sur (Xtr,Ytr) 

%Cette fonction sort une structure B. Cette structure contient
% B.alphabeta vecteur colonne de taille p+1. La premiere coordonee est l'estimation de alpha0 par Ridge calcule sur (Xtr,Ytr) avec 
%constantes de penalisation lambda.
%Les p suivantes sont les estimations de beta0 par le meme algorithme. 
%


%Ytr est un vecteur colonne contenant les labels associes aux n lignes de Xtr.

[n,p]=size(Xtr);
M=1.345;
%normalisation en variance des variables contenues dans la matrice de design de l'echantillon d'apprentissage

%sqtr=sqrt(sum(Xtr.^2));
%Xtr=Xtr*diag(1./sqtr);

cvx_begin
variables alphaa betaanaive(p) s v(n);
minimize (n*s+quad_over_lin(Ytr-alphaa-Xtr*betaanaive-v,s)+2*M*norm(v,1)+lambda*quad_over_lin(betaanaive,1))
subject to
s > 0;
cvx_end

salphabeta=[s;alphaa;betaanaive];
B.salphabeta=salphabeta;
