function E = Ridgecvdetails(Xtr,Ytr,Xte,Yte,lambda)
%cette fonction calcul et sort l'erreur de prediction E calculee sur (Yte,Xte) de 
%l'estimateur calcule par Ridge sur (Xtr,Ytr) avec constante de
%penalisation lambda. 


%Ytr est un vecteur colonne de taille 4n/5 contenant les labels associes aux 4n/5 lignes de Xtr
%Yte est un vecteur colonne de taille n/5 contenant les labels associes aux n/5 lignes de Xte


[n5,p]=size(Xtr);
M=1.345;
%normalisation en variance des variables contenues dans la matrice de design contenant  4n/5 individus (lignes de Xtr)
%sqtr=sqrt(sum(Xtr.^2));
%Xtr=Xtr*diag(1./sqtr);

%normalisation en variance des variables contenues dans la matrice de design contenant  n/5 individus ( autres lignes de Xtr) afin de pouvoir calculer l'erreur de prediction
%sqte=sqrt(sum(Xte.^2));

cvx_begin
variables alphaa betaanaive(p) s v(n5);
minimize (n5*s+quad_over_lin(Ytr-alphaa-Xtr*betaanaive-v,s)+2*M*norm(v,1)+lambda*quad_over_lin(betaanaive,1))
subject to 
s > 0;
cvx_end

E=mean((Yte-alphaa-Xte*betaanaive).^2);
