function f = PerteQuadratiquePenENAdapBruitDoubleExp(n,m,sig,G1,G2,M)
%%%Inputs:
%n size of each training sample.
%m size of the test sample.
%
%sig a parameter of the model (not necessarily the variance of the noise).
%G1 cross-validation grid for lambda_1.
%G2 cross-validation grid for lambda_2.
%M number of training samples.

%%%Outputs:
%f.alphabeta estimations of alpha and beta.
%f.RPE Relative Prediction Error.
%f.lambdaopt regularization parameters.

%intercept of the model
alpha0=1;

%coefficient of each covariable
beta0=[3*ones(15,1);zeros(25,1)];
p=length(beta0);

%alphabeta starts at 0
alphabeta=zeros(p+1,M);

%lambdaopt starts at 0
lambdasopt=zeros(2,M); 

% Reseting the generator of random numbers to its initial state 

rand('state',0); 

randn('state',0);

%generating the design matrix of each training sample

Xtr=XgenerationVeryStrongCorrGroupEffect(n);

%generating the test sample

Xte=XgenerationVeryStrongCorrGroupEffect(m);

for j=1:M,

%generating the labels of the training sample according to the model
Ytr=alpha0+Xtr*beta0+sig*doubleexprnd(n)';

%Calculation of the estimator on the training sample
H=ElasticNetXYcvforpaper2Adap(Xtr,Ytr,G1,G2);
alphabeta(:,j)=H.alphabeta;
lambdasopt(:,j)=H.lambdasopt;

end
%Calculation of the RPE on the test set
beta=alphabeta(2:end,:);
alpha=alphabeta(1,:);
betaerr=beta-repmat(beta0,1,M);
alphaerr=alpha-repmat(alpha0,1,M);
alphaerr1=repmat(alphaerr,m,1);
%sqte=sqrt(sum(Xte.^2));
%alphabetaerr=alphaerr1+(Xte*diag(1./sqte))*betaerr;
alphabetaerr=alphaerr1+Xte*betaerr;
RPE=mean(alphabetaerr.^2,1)/(2*sig^2);


f.alphabeta=alphabeta;
f.RPE=RPE;
f.lambdasopt=lambdasopt;

save alphabeta3400ENAdap.dat -ASCII alphabeta
save RPE3400ENAdap.dat -ASCII RPE
save lambdasopt3400ENAdap.dat -ASCII lambdasopt


