function f = IHccadapXYlambdaforBIC(Xtr,Ytr,lambda,L,betaUNP)

%%%Inputs:
%Xtr matrix design of the training data.
%Ytr labels vector of the training data.
%lambda regularization parameter.
%betaUNP unpenalized estimator of the training data. 

%%%Outputs:
%f.talphabeta estimations of alpha and beta with regularisation parameter lambda.


p=length(betaUNP);

%Calculating the estimations of tau, alpha and beta.

cvx_begin
variables alphaa betaa(p) tau w(p);
minimize (quad_over_lin(Ytr-alphaa-Xtr*betaa,1)+ lambda*(tau*norm(betaUNP,1)+quad_over_lin(w./(sqrt(abs(betaUNP))),2*L*tau)+norm(betaa./betaUNP,1)-sum(w./abs(betaUNP))+0.5*L*tau*norm(1./betaUNP,1)))
subject to
tau > 0;
w >= L*tau;
w >= abs(betaa);
cvx_end
f.talphabeta=[tau;alphaa;betaa(:)];
