function f = PerteQuadratiquePenIHccAdapBruitDoubleExp(n,m,sig,G,M)
%%%Inputs:
%n size of each training sample.
%m size of the test sample.
%G grid for the BIC choice of lambda
%sig a parameter of the model (not the variance of the noise which is 15 for sig=15/sqrt(2)).
%M number of training samples.

%%%Outputs:
%f.talphabeta estimations of tau, alpha and beta.
%f.RPE Relative Prediction Error.
%f.lambdaopt regularization parameter.

%intercept of the model
alpha0=1;

%coefficient of each covariable
beta0=[3*ones(15,1);zeros(25,1)];
p=length(beta0);

%talphabeta starts at 0
talphabeta=zeros(p+2,M);

%lambdaopt starts at 0
lambdaopt=zeros(1,M); 

% Reseting the generator of random numbers to its initial state 

rand('state',0); 

randn('state',0);

%generating the design matrix of each training sample

Xtr=XgenerationVeryStrongCorrGroupEffect(n);

%generating the test sample

Xte=XgenerationVeryStrongCorrGroupEffect(m);


for j=1:M,

%generating the labels of the training sample according to the model
Ytr=alpha0+Xtr*beta0+sig*doubleexprnd(n)';

%Calculation of the estimator on the training sample
H=IHccXYBIC(Xtr,Ytr,G);
talphabeta(:,j)=H.talphabeta;
lambdaopt(:,j)=H.lambdaopt;

end
%Calculation of the RPE on the test set
beta=talphabeta(3:end,:);
alpha=talphabeta(2,:);
betaerr=beta-repmat(beta0,1,M);
alphaerr=alpha-repmat(alpha0,1,M);
alphaerr1=repmat(alphaerr,m,1);
%sqte=sqrt(sum(Xte.^2));
%alphabetaerr=alphaerr1+(Xte*diag(1./sqte))*betaerr;
alphabetaerr=alphaerr1+Xte*betaerr;
RPE=mean(alphabetaerr.^2,1)/(2*sig^2);


f.talphabeta=talphabeta;
f.RPE=RPE;
f.lambdaopt=lambdaopt;

save talphabeta3400IHccBIClambda.dat -ASCII talphabeta
save RPE3400IHccBIClambdamod2.dat -ASCII RPE
save lambdaopt3400IHccBIClambdamod2.dat -ASCII lambdaopt


