function B = RidgeXYlambda(Xtr,Ytr,lambda)

%Cette fonction sort et etudie Ridge :
%l'estimateur est calcule sur (Xtr,Ytr) 

%Cette fonction sort une structure B. Cette structure contient
% B.alphabeta vecteur colonne de taille p+1. La premiere coordonee est l'estimation de alpha0 par Ridge calcule sur (Xtr,Ytr) avec 
%constantes de penalisation lambda.
%Les p suivantes sont les estimations de beta0 par le meme algorithme. 
%


%Ytr est un vecteur colonne contenant les labels associes aux n lignes de Xtr.

[toto,p]=size(Xtr);

%normalisation en variance des variables contenues dans la matrice de design de l'echantillon d'apprentissage

%sqtr=sqrt(sum(Xtr.^2));
%Xtr=Xtr*diag(1./sqtr);

cvx_begin
variables alphaa betaanaive(p);
minimize (quad_over_lin(Ytr-alphaa-Xtr*betaanaive,1)+lambda*quad_over_lin(betaanaive,1))
cvx_end

alphabeta=[alphaa;betaanaive];
B.alphabeta=alphabeta;
